using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TargetController.Common;
using VirtuosoComponentLibrary;
using CuriosityBoardLibrary;

namespace FifteenSegDisplay_Host
{
	public class FifteenSegDisplay_TargetViewModel : FifteenSegDisplay_TargetModel
	{
		public FifteenSegDisplay_TargetViewModel()
		{
			InitializeComponents();
		}

		public FifteenSegDisplay_TargetViewModel (ITargetHostingConfiguration TargetConfiguration) : base(TargetConfiguration)
		{
			InitializeComponents();
		}

		private void InitializeComponents()
		{
			// Add component(s) here....
			_PowerButton = new PowerButtonViewModel(this, "VirtualDeviceIsPowered", LEDTileImage.Tile1, PowerButtonColor.Blue);

            // Initialize the FifteenSegDisplay View Model. It will bind to SIM_FifteenSegmentValue variable in target
            _FifteenSegVM = new FifteenSegmentDisplayViewModel(this, "SIM_FifteenSegmentValue", 0);
		}

		private PowerButtonViewModel _PowerButton;
		public PowerButtonViewModel PowerButton
		{
			get
			{
				return _PowerButton;
			}
		}

        private FifteenSegmentDisplayViewModel _FifteenSegVM;
        public FifteenSegmentDisplayViewModel FifteenSegVM
        {
            get
            {
                return _FifteenSegVM;
            }
        }
	}
}
