/************************************************************************************
*
* This file is controlled by Virtuoso........
*
************************************************************************************/
#define VIRTUOSO_C
#ifdef __cplusplus
extern "C" {
#endif

#include <windows.h>

HINSTANCE hinstLib;
typedef int(*FuncMonitorCommBuffers)(void);
typedef int(*FuncEnterCriticalSec)(void);
typedef int(*FuncLeaveCriticalSec)(void);
typedef int(*FuncWriteBufferStream)(unsigned int hHandle, unsigned char* pSource, unsigned int Length);
typedef int(*FuncWriteTextStream)(unsigned int hHandle, unsigned char Txt[]);
typedef int(*FuncVirtuosoReadyState)(void);

FuncEnterCriticalSec _FuncEnterCriticalSec;
FuncLeaveCriticalSec _FuncLeaveCriticalSec;
FuncWriteBufferStream _FuncWriteBufferStream;
FuncWriteTextStream _FuncWriteTextStream;

void InitializeVirtuoso(void)
{
   char FileNamePath[256];
   char DLLName[] = "\\FrameworkEmbeddedDLL.dll";
   GetModuleFileName(0, FileNamePath, MAX_PATH);
   for (int i = strlen(FileNamePath); i>0; i--)
   {
      if (FileNamePath[i] == '\\')
      {
         for (unsigned int j = 0; j < strlen(DLLName); j++)
         {
            FileNamePath[i++] = DLLName[j];
         }
         FileNamePath[i] = '\0';
         break;
      }
   }
   hinstLib = LoadLibrary(FileNamePath);
   if( hinstLib != NULL)
   {
      OutputDebugString(FileNamePath);
   }
   else
   {
      hinstLib = LoadLibrary("C:\\Program Files\\Embeddetech\\Virtuoso\\Resources\\Embedded\\FrameworkEmbeddedDLL.dll");
      OutputDebugString("C:\\Program Files\\Embeddetech\\Virtuoso\\Resources\\Embedded\\FrameworkEmbeddedDLL.dll");
   }
   FuncMonitorCommBuffers _FuncMonitorCommBuffers = (FuncMonitorCommBuffers)GetProcAddress(hinstLib, "MonitorCommBuffers");
   if (_FuncMonitorCommBuffers)	// If the function address is valid, call the function.
   {
      _FuncMonitorCommBuffers();
   }
   _FuncEnterCriticalSec = (FuncEnterCriticalSec)GetProcAddress(hinstLib, "EnterCriticalSec");
   _FuncLeaveCriticalSec = (FuncLeaveCriticalSec)GetProcAddress(hinstLib, "LeaveCriticalSec");
   _FuncWriteBufferStream = (FuncWriteBufferStream)GetProcAddress(hinstLib, "WriteBufferStream");
   _FuncWriteTextStream = (FuncWriteTextStream)GetProcAddress(hinstLib, "WriteTextStream");
   UINT8 state = 0;
   FuncVirtuosoReadyState _FuncVirtuosoReadyState = (FuncVirtuosoReadyState)GetProcAddress(hinstLib, "GetVirtuosoReadyState");
   if (_FuncVirtuosoReadyState)
   {
      while (1)
      {
         state = _FuncVirtuosoReadyState();
         if (state == 1)
         {
            break;
         }
         else
         {
            Sleep(200);
         }
      }
   }
}

void BeginCriticalSection(void)
{
   if (_FuncEnterCriticalSec)	// If the function address is valid, call the function.
   {
      _FuncEnterCriticalSec();
   }
}

void EndCriticalSection(void)
{
   if (_FuncLeaveCriticalSec)	// If the function address is valid, call the function.
   {
      _FuncLeaveCriticalSec();
   }
}

void WriteBufferToVirtuosoUpStream(int hHandle, unsigned char* pSource, int Length)
{
   if (_FuncWriteBufferStream)	// If the function address is valid, call the function.
   {
      _FuncWriteBufferStream(hHandle, pSource, Length);
   }
}

void WriteStringToVirtuosoUpStream(int hHandle, unsigned char Txt[])
{
   if (_FuncWriteTextStream)	// If the function address is valid, call the function.
   {
      _FuncWriteTextStream(hHandle, Txt);
   }
}

#ifdef __cplusplus
}
#endif
